﻿using System;

// Själva delegatdeklarationen
public delegate int Comparer(object obj1, object obj2);

// ”Testklass”
public class Name {
    public string FirstName = null;
    public string LastName = null;
    public Name(string first, string last) {
        FirstName = first;
        LastName = last;
    }

    // En möjlig delegat
    public static int CompareFirstNames(object name1, object name2)
    {
        string n1 = ((Name)name1).FirstName;
        string n2 = ((Name)name2).FirstName;
        if (String.Compare(n1, n2) > 0)
            return 1;
        else if (String.Compare(n1, n2) < 0)
            return -1;
        else
            return 0;
    }

    public override string ToString()
    {
        return FirstName + " " + LastName;
    }
} // Slut på testklassen Name

// Huvudprogrammet
class SimpleDelegate {
    Name[] names = new Name[4];

    public SimpleDelegate() {
        names[0] = new Name("Nils", "Nilsson");
        names[1] = new Name("Otto", "Olsson");
        names[2] = new Name("Nils", "Jonsson");
        names[3] = new Name("Lena", "Ohlsson");
    }

    static void Main(string[] args) {
        SimpleDelegate sd = new SimpleDelegate();
        // Här skapas delegat-objektet (i detta fall en ”jämförare”)
        Comparer cmp = new Comparer(Name.CompareFirstNames);
        Console.WriteLine("\nBefore Sort: \n");
        sd.PrintNames();
        // Lägg märke till delegat-argumentet!
        sd.Sort(cmp);
        Console.WriteLine("\nAfter Sort: \n");
        sd.PrintNames();

        Console.ReadKey();  // Vänta på inmatning
    }

    public void Sort(Comparer compare) {
        object temp;
        for (int i=0; i < names.Length; i++) {
            for (int j=i; j < names.Length; j++) {
                // Använd delegaten "compare" som om det vore en metod
                if ( compare(names[i], names[j]) > 0 ) {
                    // Byt plats
                    temp = names[i];
                    names[i] = names[j];
                    names[j] = (Name)temp;
                }
            }
        }
    }

    public void PrintNames()
    {
        Console.WriteLine("Names: \n");
        foreach (Name name in names)
        {
            Console.WriteLine(name.ToString());
        }
    }
}   // SimpleDelegate